/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.listener;

import com.comphenix.tinyprotocol.TinyProtocol;
import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.utils.CraftbukkitWrapper;
import de.steamwar.linkage.Linked;
import net.minecraft.network.protocol.game.ServerboundUseItemOnPacket;
import org.bukkit.entity.Player;

import java.io.*;

@Linked
public class ClickAnalyzer {

    private static final PrintStream output;

    static {
        try {
            output = new PrintStream(new BufferedOutputStream(new FileOutputStream(new File(Config.world.getWorldFolder(), "clicks.csv"))));
        } catch (FileNotFoundException e) {
            throw new SecurityException(e);
        }
    }

    public ClickAnalyzer() {
        TinyProtocol.instance.addFilter(Recording.blockPlacePacket, this::onBlockPlace);
        TinyProtocol.instance.addFilter(ServerboundUseItemOnPacket.class, this::onBlockPlace);
    }

    public Object onBlockPlace(Player player, Object packet) {
        synchronized (output) {
            output.println(player.getName() + "," + System.nanoTime() + "," + CraftbukkitWrapper.impl.headRotation(player) + "," + player.getLocation().getPitch());
        }
        return packet;
    }

    public static void close() {
        output.close();
    }
}
